#include <iostream>
#include "vektor.h"
using namespace std;


vektor::vektor(int n)
: delka(n), pole(new double[n]{})
{
}

vektor::vektor(initializer_list<double> il)
{
    delka = il.size();
    pole = new double[delka];
    int i = 0;
    for(double x: il)
    {
        pole[i++]=x;
    }
}

vektor::~vektor()
{
    delete[] pole;
}


void vektor::vypis()
{
    for(int i = 0; i < delka; i++)
    {
        cout << pole[i] << " ";
    }
    cout << endl;
}