#include "obrazek.h"

void obrazek::proved_kresleni()
{
	for (auto go : kresba)
	{
		go->proved_kresleni();
	}
}

void obrazek::proved_mazani()
{
	for (auto p : kresba)
	{
		p->proved_mazani();
	}
}

obrazek * obrazek::klon()
{
	return new obrazek(*this);
}

obrazek::obrazek()
{
}

obrazek::obrazek(obrazek & obr)
{
	for(auto p: obr.kresba)
	{ 
		kresba.push_back(p->klon());
	}
}


obrazek::~obrazek()
{
	for (auto p : kresba)
	{
		delete p;
	}
}

void obrazek::pridej(graficky_objekt& go)
{
	kresba.push_back(go.klon());
}

