#include <sstream>
#include <unordered_map>
#include "komparatory.h"

using namespace std;

bool podle_cisel(string lajna1, string lajna2)
{
	istringstream vstup1(lajna1), vstup2(lajna2);
	int n1, n2;
	vstup1 >> n1;
	vstup2 >> n2;
	return n1 < n2;
}

bool lexikograficky(string lajna1, string lajna2)
{
	return lajna1 < lajna2;
}

string zastup(string);

bool abecedne(string lajna1, string lajna2)
{
	return zastup(lajna1) < zastup(lajna2);
}

static unordered_map<char, char> mala_na_velka
{
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
	{ '', '' },
};

static unordered_map< string, pair<string, char>> uprava
{
	{ "A",{ "Aa", 'a' } },
	{ "",{ "Aa", 'b' } },
	{ "",{ "Aa", 'e' } },
	{ "B",{ "Ba", 'a' } },
	{ "C",{ "Ca", 'a' } },
	{ "",{ "Cb", 'a' } },
	{ "D",{ "Da", 'a' } },
	{ "",{ "Da", 'b' } },
	{ "E",{ "Ea", 'a' } },
	{ "",{ "Ea", 'b' } },
	{ "",{ "Ea", 'c' } },
	{ "F",{ "Fa", 'a' } },
	{ "G",{ "Ga", 'a' } },
	{ "H",{ "Ha", 'a' } },
	{ "CH",{ "Hb", 'a' } },
	{ "I",{ "Ia", 'a' } },
	{ "",{ "Ia", 'b' } },
	{ "J",{ "Ja", 'a' } },
	{ "K",{ "Ka", 'a' } },
	{ "L",{ "La", 'a' } },
	{ "",{ "La", 'b' } },
	{ "",{ "La", 'c' } },
	{ "M",{ "Ma", 'a' } },
	{ "N",{ "Na", 'a' } },
	{ "",{ "Na", 'b' } },
	{ "O",{ "Oa", 'a' } },
	{ "",{ "Oa", 'b' } },
	{ "",{ "Oa", 'f' } },
	{ "P",{ "Pa", 'a' } },
	{ "Q",{ "Qa", 'a' } },
	{ "R",{ "Ra", 'a' } },
	{ "",{ "Ra", 'b' } },
	{ "",{ "Rb", 'a' } },
	{ "S",{ "Sa", 'a' } },
	{ "",{ "Sb", 'a' } },
	{ "T",{ "Ta", 'a' } },
	{ "",{ "Ta", 'b' } },
	{ "U",{ "Ua", 'a' } },
	{ "",{ "Ua", 'b' } },
	{ "",{ "Ua", 'd' } },
	{ "V",{ "Va", 'a' } },
	{ "W",{ "Wa", 'a' } },
	{ "X",{ "Xa", 'a' } },
	{ "Y",{ "Ya", 'a' } },
	{ "",{ "Ya", 'b' } },
	{ "Z",{ "Za", 'a' } },
	{ "",{ "Zb", 'a' } },
	{ " ",{ " ", ' ' } },
};

char velke(char znak)
{
	if ((znak >= 'a') && (znak <= 'z'))
	{
		return znak - 'a' + 'A';
	}
	if (mala_na_velka.find(znak) != mala_na_velka.end())
	{
		return mala_na_velka[znak];
	}
	return znak;
}

string velke(string text)
{
	string vysledek;
	for (char p : text)
	{
		vysledek += velke(p);
	}
	return vysledek;
}

string zastup(string text)
{
	string primarni, sekundarni, pismeno;
	string TEXT = velke(text);
	for (unsigned i = 0; i < TEXT.length(); i++)
	{
		pismeno.clear();
		pismeno += TEXT[i];
		if ((TEXT[i] == 'C') && (i + 1 < TEXT.length()) && (TEXT[i + 1] == 'H'))
		{
			pismeno += 'H';
			i++;
		}
		primarni += uprava[pismeno].first;
		sekundarni += uprava[pismeno].second;
	}
	return primarni + ' ' + sekundarni;
}
