#ifndef __ABECEDNI_KOMPARATOR_H__
#define __ABECEDNI_KOMPARATOR_H__

#include <string>
#include <unordered_map>
#include <map>
#include <utility>

#include "komparator.h"

using namespace std;

class abecedni_komparator : public komparator
{
	unordered_map<char, char> mala_na_velka;
	unordered_map< string, pair<string, char>> uprava;
	unordered_map<char, char> slozena_pismena;

	char velke(char znak);
	string velke(string text);
	string zastup(string text);
public:
	abecedni_komparator();
	virtual bool operator()(string lajna1, string lajna2);
};

#endif // __ABECEDNI_KOMPARATOR_H__
