#include <iostream>
#include <string>
using namespace std;

template<typename T>
T max(T a, T b)
{
    return a > b ? a : b;
}

template<typename T1, typename T2>
class dvojice
{
public:
    dvojice(T1 _prvni, T2 _druha);
    dvojice(){}
    T1 prvni();
    T2 druha();
    void prvni(T1 _prvni);
    void druha(T2 _druha);
private:
    T1 prvni_slozka;
    T2 druha_slozka;
};


template<typename T1, typename T2>
dvojice<T1, T2>::dvojice(T1 _prvni, T2 _druha)
{
    prvni(_prvni);
    druha(_druha);
}

template<class T1, class T2>
void dvojice<T1, T2>::prvni(T1 _prvni)
{
    prvni_slozka = _prvni;
}

template<class T1, class T2>
void dvojice<T1, T2>::druha(T2 _druha)
{
    druha_slozka = _druha;
}

template<class T1, class T2>
T1 dvojice<T1, T2>::prvni()
{
    return prvni_slozka;
}

template<class T1, class T2>
T2 dvojice<T1, T2>::druha()
{
    return druha_slozka;
}


int main()
{
    dvojice<int, int> dva{};
    dvojice<string, int> kontakt{"Josef Novk", 1234567};
    cout << kontakt.prvni() << endl;
    return 0;
}
