#include "strom.h"
#include "uzel.h"
#include <iostream>
#include <limits>
using namespace std;

strom::strom()
{
    koren = new uzel{"rohy", true, new uzel{"vl", false, nullptr, nullptr}, new uzel{"ba", false, nullptr, nullptr}};
    // Znamen tot co
    // koren = new uzel{"rohy", true, nullptr, nullptr};
    // koren->ma = new uzel{ "vl", false, nullptr, nullptr };
    // koren->nema = new uzel{ "ba", false, nullptr, nullptr };
}

void strom::vyprazdni()
{
	vyprazdni(koren);
	koren = nullptr;
}

void strom::pridej_zvire()
{
	cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
	cout << "A co to tedy je? ";
	string zvire;
	getline(cin, zvire);
	cout << "m se li " << zvire << " a " << aktualni->znak << "? ";
	string rozdil;
	getline(cin, rozdil);
	cout << zvire << " m " << rozdil << "? ";
	string odpoved;
	cin >> odpoved;
	cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
	if (odpoved[0] == 'a')
	{
		aktualni->nema = new uzel(*aktualni);
		aktualni->ma = new uzel{ zvire, false, nullptr, nullptr };
	}
	else
	{
		aktualni->ma = new uzel(*aktualni);
		aktualni->nema = new uzel{ zvire, false, nullptr, nullptr };
	}
	aktualni->otazka = true;
	aktualni->znak = rozdil;
}

void strom::vyprazdni(uzel* koren)
{
	if (!koren) return;
	vyprazdni(koren->ma);
	vyprazdni(koren->nema);
	delete koren;
}

strom::~strom()
{
	vyprazdni();
}

string strom::hledej()
{
	aktualni = koren;
	while (aktualni->otazka)
	{
		cout << "M to " << aktualni->znak << "? ";
		string odpoved;
		cin >> odpoved;
		aktualni = odpoved[0] == 'a' ? aktualni->ma : aktualni->nema;
	}
	return aktualni->znak;
}
