#define  _CRT_SECURE_NO_WARNINGS // pro Visual C++
#include <iostream>
#include <stdio.h>
#include <stdexcept>


using namespace std;

void kontrola(FILE *proud, char *jmeno)
{
	if (!proud)
	{
		throw runtime_error(string("Nepodailo se otevt soubor ") + jmeno);
	}
}

void zapis(char *jmeno)
{
	FILE *proud = fopen(jmeno, "wb");
	kontrola(proud, jmeno);
	for (int i = 1; i <= 10; i++)
	{
		fwrite(&i, sizeof(i), 1, proud);
	}
	fclose(proud);
}

void cteni(char *jmeno)
{
	FILE *proud = fopen(jmeno, "rb");
	kontrola(proud, jmeno);
	int i;
	while (fread(&i, sizeof(int), 1, proud))
	{
		cout << i << endl;
	}
	fclose(proud);
}

void pripojeni(char *jmeno, int *co, int kolik)
{
	FILE *proud = fopen(jmeno, "ab");
	kontrola(proud, jmeno);
	fwrite(co, sizeof(int), kolik, proud);
	fclose(proud);
}

void predposledni_hodnota(char *jmeno)
{
	FILE*proud = fopen(jmeno, "rb");
	kontrola(proud, jmeno);
	fseek(proud, -2*(long)sizeof(int), SEEK_END);
	int i;
	fread(&i, sizeof(i), 1, proud);
	cout << i << endl;
}

void aktualizace(char *jmeno)
{
	FILE *proud = fopen(jmeno, "rb+");
	kontrola(proud, jmeno);
	int i;
	while (fread(&i, sizeof(int), 1, proud))
	{
		if (i % 2 == 0)				
		{
			i = i / 2;
			fseek(proud, -(long)sizeof(int), SEEK_CUR); 
			fwrite(&i, sizeof(int), 1, proud);
			fseek(proud, 0, SEEK_CUR);
		}
	}
	fclose(proud);
}

int main()
{
	int A[]{ 11,12,13,14,15,16 };
	try
	{
		zapis("data.dta");
		//pripojeni("data.dta", A, sizeof(A) / sizeof(int));
		//predposledni_hodnota("data.dta");
		aktualizace("data.dta");
		cteni("data.dta");
	}
	catch (exception &e)
	{
		cerr << e.what() << endl;
	}
}


