#include <algorithm>
#include <iostream>
#include "tridic.h"
#include "komparatory.h"


void tridic::zpracuj(volba::zvoleno_t zvoleno)
{
   	nacti();
	serad(zvoleno);
	vypis();
}


void tridic::nacti()
{
    while (getline(cin, radka))
	{
		soubor.push_back(radka);
	}
}

void tridic::serad(volba::zvoleno_t zvoleno)
{
    if(zvoleno == volba::lexikograficky)
    {
        sort(soubor.begin(), soubor.end());
    }
    else
    {
        sort(soubor.begin(), soubor.end(), podle_cisel);
    }
}

void tridic::vypis()
{
    for (auto lajna : soubor)
	{
		cout << lajna << endl;
	}
}
