#include <stdlib.h>
#include "volba.h"
#include "znaky.h"

string volba::text_napovedy = retezec_Cp1250_na_string_Cp852(R"(
SORT - program pro seazen dek danho souboru. Pouit:
sort volba < vstupn-soubor > vstupn-soubor
Mon volby:
-n nebo /n     azen podle sel na potcch dek
-l nebo /l     lexikografick azen

(C) Pikvorky software 2017
)");


volba::volba(int argc, char **argv)
{
	if (argc != 2)
		napoveda();
	if ((argv[1][0] != '-') && (argv[1][0] != '/'))
		napoveda();
	switch (argv[1][1])
	{
	case 'l':
		zjistena_volba = lexikograficky;
		return;
	case 'n':
		zjistena_volba = numericky;
		return;
	default:
		napoveda();
	}
}

void volba::napoveda()
{
	cerr << text_napovedy << endl;
	exit(1);
}

volba::zvoleno_t volba::zvoleno()
{
	return zjistena_volba;
}


